/* Quicksort developed by Charles Hardnett */
/* 7-16-93 modified by S. Rodger so that it doesn't core dump on */
/*         input by numbers in reverse order */

#include <stdio.h>
#include "xtango.h"

#define DOWN	1
#define UP	0


void ANIMInit(), ANIMInput(), ANIMDraw(), ANIMMove(), ANIMSorted(),
     ANIMExchange(), ANIMShuffle();




void quicksort();
int a[200],n;

main()
{
   int count;

   printf("Quicksort\n");
   printf("Input number of elts in array\n");
   scanf("%d",&n);

   TANGOalgoOp("BEGIN");
   ANIMInit();

   printf("Enter the elements\n");
   for (count=0; count<n; ++count)
      { scanf("%d",&a[count]);
	ANIMInput(a,count,a[count]);
      }

   printf("This may take a sec...\n");
   ANIMDraw(a,n);
   
   quicksort(0,n-1,n);
   TANGOalgoOp("END"); 

   for (count=0; count<n; ++count)
       printf("%d ",a[count]);
   printf("\n");
}


void
quicksort(lo,hi,n)
   int lo,hi,n;
{
   int i,j,part,temp;
        

   if (hi > lo)
      { if (lo == hi-1)
	   { if (a[lo] > a[hi])
		{ temp = a[lo];
		  a[lo] = a[hi];
		  a[hi] = temp;
                  ANIMExchange(a,lo,a,hi);
		}
             ANIMMove(a,lo,hi,UP); /*put splitpoint in place*/
             ANIMShuffle(a,lo,2);
             ANIMShuffle(a,hi,2);
              
             return;
	   }

	part = a[hi];
	i = lo-1;
	j = hi;

	do
	   { do
		{ 
                  i++;
                  ANIMShuffle(a,i,0);
                  ANIMShuffle(a,i,1);
		}
	     while (a[i] < part);
	     do
		{ 
                  j--;
                  ANIMShuffle(a,j,0);
                  ANIMShuffle(a,j,1);
		}
	     while ((j>i) && (a[j] > part));
	     if (j <= i) break;
		 { ANIMExchange(a,i,a,j);
                   temp = a[i];
                 }
	     a[i] = a[j];
	     a[j] = temp;
	   }
	while (j>i);

        ANIMExchange(a,i,a,hi);
	temp = a[i];
	a[i] = a[hi];
	a[hi] = temp;
   

        ANIMMove(a,lo,hi,UP); /*put splitpoint in place*/
        
        ANIMShuffle(a,i,2);
   
        ANIMMove(a,lo,i-1,DOWN);
        ANIMMove(a,i+1,hi,DOWN);

	quicksort(lo, i-1, n);
	quicksort(i+1, hi, n);
      }
      else if (lo < n)
         ANIMShuffle(a,lo,2); 
}
