/**************************************************************/
/*							      */
/*		XTANGO ANIMATION PACKAGE (op)		      */
/*							      */
/**************************************************************/
/*	Copyright 1990 Georgia Institute of Technology	      */
/*		John T. Stasko and Doug Hayes		      */
/**************************************************************/
/*							      */
/* Modification Date  Description			      */
/* -----------------  --------------------------------------- */
/* 90/10/26 JDH	      Baselined source.                       */
/*							      */
/**************************************************************/

/**************************************************************/
/*****************	 include files       ******************/ 
/**************************************************************/

#include "xtangolocal.h"

/**************************************************************/
/*****************	LOCAL data types     ******************/
/**************************************************************/

/**************************************************************/
/*****************	GLOBAL variables     ******************/
/**************************************************************/

/**************************************************************/
/*****************	LOCAL variables      ******************/
/**************************************************************/

#define FUNCT_NOT_FOUND    -1
#define FUNCT_INIT         -2
#define FUNCT_ALREADY_INIT -3
#define FUNCT_END          -4

/**************************************************************/
/*****************      LOCAL functions      ******************/
/**************************************************************/

int find_function();

/**************************************************************/
/*****************	  entry points       ******************/
/**************************************************************/

char *TANGOalgoOp();


/**************************************************************/
/* TANGOalgoOp -- Call all functions on the named function-   */
/*		  list and return the appropriate type from   */
/*		  the last function called.		      */
/* 							      */
/* RETURNS:  Appropriate type from last function called.      */
/**************************************************************/
char *
TANGOalgoOp(fname)
   char *fname;
{
   char *retval = NULL;
   int  i,j;

   if (TANGO__data)
      DEBUG("TANGOalgoOp(\"%s\")\n", fname);

   switch (i = find_function(fname)) {
      case FUNCT_NOT_FOUND    : COMPLAIN("ERROR: TANGOalgoOp: %s (\"%s\")\n",
					 "unknown function name", fname); break;
      case FUNCT_INIT	      : TANGOinit(); break;
      case FUNCT_ALREADY_INIT : COMPLAIN("WARNING: TANGOalgoOp: BEGIN %s\n",
					 "called again"); break;
      case FUNCT_END	      : TANGOend(); break;
      }
   return retval;
}



/**************************************************************/
/* find_function -- Find function-list corresponding to name. */
/* 							      */
/* RETURNS:  TRUE(1) if found or FALSE(0).		      */
/**************************************************************/
int
find_function(fname)
   char *fname;
{
   int i, found;

   if (!strcmp(fname, "BEGIN"))
      return (TANGO__data ? FUNCT_ALREADY_INIT : FUNCT_INIT);
   else if (!strcmp(fname, "END"))
      return FUNCT_END;
   else  
      return FUNCT_NOT_FOUND;
}

/**************************************************************/
/*****************     end of xtangoop.c     ******************/
/**************************************************************/
